package com.izouma.nineth.web;

import com.izouma.nineth.domain.Collection;
import com.izouma.nineth.domain.FileObject;
import com.izouma.nineth.dto.CollectionDTO;
import com.izouma.nineth.dto.CreateBlindBox;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.CollectionRepo;
import com.izouma.nineth.service.CollectionService;
import com.izouma.nineth.service.LikeService;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.SecurityUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/collection")
@AllArgsConstructor
public class CollectionController extends BaseController {
    private CollectionService collectionService;
    private CollectionRepo    collectionRepo;
    private LikeService       likeService;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Collection save(@RequestBody Collection record) {
        Collection orig = collectionRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
        ObjUtils.merge(orig, record);
        return collectionRepo.save(orig);
    }

    @PostMapping("/create")
    public Collection create(@RequestBody Collection record) {
        return collectionService.create(record);
    }

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<CollectionDTO> all(@RequestBody PageQuery pageQuery) {
        return collectionService.toDTO(collectionService.all(pageQuery));
    }

    @GetMapping("/get/{id}")
    public CollectionDTO get(@PathVariable Long id) {
        return collectionService.toDTO(collectionRepo.findById(id).orElseThrow(new BusinessException("无记录")), true);
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        collectionRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Collection> data = collectionService.all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @GetMapping("/{id}/like")
    @ApiOperation("点赞")
    @CacheEvict("collection")
    public void like(@PathVariable Long id) {
        likeService.like(SecurityUtils.getAuthenticatedUser().getId(), id);
    }

    @GetMapping("/{id}/unlike")
    @ApiOperation("取消点赞")
    @CacheEvict("collection")
    public void unlike(@PathVariable Long id) {
        likeService.unlike(SecurityUtils.getAuthenticatedUser().getId(), id);
    }

    @GetMapping("/myLikes")
    @ApiOperation("我收藏的")
    public List<CollectionDTO> myLikes() {
        return collectionService.toDTO(collectionRepo.userLikes(SecurityUtils.getAuthenticatedUser().getId()));
    }

    @PostMapping("/createBlindBox")
    public Collection createBlindBox(@RequestBody CreateBlindBox createBlindBox) {
        return collectionService.createBlindBox(createBlindBox);
    }

    @PostMapping("/appointment")
    public void appointment(@RequestParam Long id) {
        collectionService.appointment(id, SecurityUtils.getAuthenticatedUser().getId());
    }

    @GetMapping("/recommend")
    public List<CollectionDTO> recommend(@RequestParam String type) {
        return collectionService.toDTO(collectionRepo.recommend(type).stream().map(rc -> {
            if (StringUtils.isNotBlank(rc.getRecommend().getPic())) {
                rc.getCollection().setPic(Collections.singletonList(new FileObject(null, rc.getRecommend()
                        .getPic(), null, null)));
            }
            return rc.getCollection();
        }).collect(Collectors.toList()));
    }
}

